
import 'package:origami_telegram/services/stateMachine/actionButton.dart';

enum TelegramResponseType
{
  Text,
  Image,
  Doc,
  Audio,
  Video
}
class TelegramResponseModel
{
  bool inlineKeyboard=true;
  String text='';
  String photo='';
  String parseMode;
  TelegramResponseType type=TelegramResponseType.Text;
  List<List<ActionButton>> button=[];
  TelegramResponseModel();
  String state='';
  dynamic toJson()
  {
    dynamic obj={};
    obj['text']=text; 
    obj['photo']=photo;
    obj['parseMode']=parseMode;
    obj['state']=state;
    obj['type']=type.toString().replaceAll('TelegramResponseType.', '');
    obj['inlineKeyboard']=inlineKeyboard;
    dynamic jsonButton=[];
    for(var a in button)
    {
      jsonButton.add(ActionButton.toJsonList(a));
    }
    obj['button']=jsonButton;
    return obj;
  }
  TelegramResponseModel.fromJson(dynamic data)
  {
    if(data['inlineKeyboard']!=null) inlineKeyboard=data['inlineKeyboard'];
    if(data['text']!=null) text=data['text'];
    if(data['photo']!=null) photo=data['photo'];
    if(data['state']!=null) state=data['state'];
    if(data['parseMode']!=null) parseMode=data['parseMode'];
    if(data['type']=='Audio') type=TelegramResponseType.Audio;
    if(data['type']=='Text') type=TelegramResponseType.Text;
    if(data['type']=='Image') type=TelegramResponseType.Image;
    if(data['type']=='Doc') type=TelegramResponseType.Doc;
    if(data['type']=='Video') type=TelegramResponseType.Video;
    if(data['button']!=null)
    {
      button=[];
      for(var row in data['button'])
      {
        if(row!=null)
        {
          var l= ActionButton.fromJsonList(row);
          button.add(l);
        }
      }
    }
  }
}